import es
import playerlib
from JoeyCMDs import JoeyCMDs

est = JoeyCMDs("est")

all_users = es.ServerVar("all_users", 1, "1= all users 0= only admins")
spec_killed = es.ServerVar("spec_killed", 0, "0=regular 1=if you are killed at spec")
spec_deathmatch = es.ServerVar("spec_deathmatch", 0, "0=you reenter game yet wait round start 1=you reenter game instantly")

spec_players = {} # Define our empty dictionary

info = es.AddonInfo()
info.name     = "Spec & Unspec"
info.version  = "1.1"
info.url      = "http://addons.eventscripts.com/addons/view/"
info.basename = "spec_unspec"
info.author   = "Juba_PornBorn"

def load():
    es.ServerVar("spec_unspec", "1.0").makepublic()
    
    if all_users == 1:
        es.regsaycmd('!spec', 'spec_unspec/spectate')
        es.regsaycmd('!unspec', 'spec_unspec/unspectate')
    else:
        es.server.cmd('clientcmd create say !spec spec_unspec/spectate "" #admin')
        es.server.cmd('clientcmd create say !unspec spec_unspec/unspectate "" #admin')
        
def spectate():
    global spec_players # We need this to be global to change it
    player = playerlib.getPlayer(es.getcmduserid())    
    
    if player.get('teamid') not in (2, 3) and player.get('isdead') != 0: 
        es.tell(player, 'You cannot use !spec while a spectator or dead') 
        return

    spec_players[int(player)] = {'kills':player.get('kills'), 'deaths':player.get('deaths'), 'team':player.get('teamid')}
    es.changeteam(int(player),'1')
    
def unspectate():
    global spec_players
    userid = es.getcmduserid() 

    if userid not in spec_players: 
        es.tell(userid, 'No spectator data found') 
        return
    
    if spec_deathmatch == 0:
        es.changeteam(userid, player_data['team'])
    if spec_deathmatch == 1:
        est.team(userid, spec_players[userid]['team']) 
        
    #if spec_killed == 0:
    if spec_killed == 1:    
        spec_players[userid]['kills'] += 1
        spec_players[userid]['deaths'] -= 1
            
        est.killset(userid, spec_players[userid]['kills'])
        est.deathset(userid, spec_players[userid]['deaths'])
            
        #es.tell(userid, "kill:%s death:%s" %(spec_players[userid]['kills'], spec_players[userid]['deaths']))   
    del spec_players[userid]
    
def player_disconnect(event_var): 
    global spec_players 
    userid = int(event_var['userid']) # Keys in our dictionary are stored as integers 
    if userid in spec_players: 
        del spec_players[userid] # Remove the key of the disconnected player 


def es_map_start(event_var): 
    spec_players.clear() # Clear all keys for the new map